# The React Hooks - TypeScript project template
This project is generated by [code-template-generator](https://www.npmjs.com/package/code-template-generator). View more information and other project templates on [GitHub](https://github.com/nguyenkhois/build-environments).

## Dependencies
Main packages:
* [React Hooks](https://reactjs.org/)
* [TypeScript](https://www.typescriptlang.org/docs/handbook/react-&-webpack.html)
* [Awesome TypeScript loader for webpack](https://github.com/s-panferov/awesome-typescript-loader)
* [Webpack](https://webpack.js.org/concepts/)
* [Webpack Dev Server](https://webpack.js.org/configuration/dev-server/)
* [Optimize CSS Assets plugin for Webpack](https://github.com/NMFR/optimize-css-assets-webpack-plugin)
* [Terser plugin for Webpack](https://github.com/webpack-contrib/terser-webpack-plugin)

## Features
|Description|Location|
|---|---|
|Source code|`/src`|
|Images|`/src/images`|
|Styles|`/src/styles`|
|HTML template|`/src/index.html`|
|Main entry point|`/src/index.tsx`|
|Webpack Dev Server custom config|`/webpack.custom.js`|

* Auto refresh whenever you make a change in your code.
* Your code are compiled into the directory `/dist` with three separate file extensions `*.html, *.css, *.js`.
* Directory `/dist` is deleted and then created automatic whenever you run the command `npm run build`.

View more about the features on [GitHub](https://github.com/nguyenkhois/build-environments).

Tested on:
* Windows 10 version 1903
* MacOS version 10.13
* Ubuntu version 18.04 LTS

## Usage
* The commands:
    * `npm install` - Installs all needed dependencies.
    * `npm run start` - Starts Webpack Dev Server by the development mode.
    * `npm run build` - Bundles your app into the folder `/dist` by the production mode.
* Local web server is started at `htpp://localhost:9000`

## About TypeScript

You may want to know more about TypeScript:
* [TypeScript with React and Webpack](https://www.typescriptlang.org/docs/handbook/react-&-webpack.html)
* [TypeScript documentation](https://www.typescriptlang.org/docs/handbook/release-notes/typescript-3-0.html)
* [What's new in version 3.0](https://blogs.msdn.microsoft.com/typescript/2018/07/30/announcing-typescript-3-0/)
* [Announcing TypeScript 3.6](https://devblogs.microsoft.com/typescript/announcing-typescript-3-6/)
